=== debian/changelog ===
oclgrind (18.3-2) unstable; urgency=medium

  * Switch to LLVM/Clang 7.  (Closes: #912796)
  * Cherry-pick upstream patch for linking with Clang 7.
  * Drop versioned constraints that are satisfied in jessie.
  * Switch to debhelper-compat (= 12).
  * Bump Standards-Version to 4.1.3. No changes needed.
  * Add myself to Uploaders.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 03 Feb 2019 14:27:59 +0100

oclgrind (18.3-1) unstable; urgency=low

  [ James Price ]
  * New upstream release
  * Refresh patches, drop those applied upstream
  * Update to LLVM/Clang 6.0 (Closes: #873422)
  * Bump Standards-Version to 4.1.3
  * Add debian/upstream/metadata file

  [ Andreas Beckmann ]
  * Switch Vcs-* URLs to salsa.debian.org.
  * Install NEWS as upstream changelog.

 -- James Price <j.price@bristol.ac.uk>  Sun, 11 Mar 2018 09:31:39 +0000
