=== debian/control ===
Source: oclgrind
Section: devel
Priority: optional
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 James Price <j.price@bristol.ac.uk>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 12),
 dh-exec,
 cmake,
 llvm-7-dev,
 libclang-7-dev,
 clang-7,
 libedit-dev,
 zlib1g-dev,
 libreadline-dev,
 opencl-c-headers,
 python,
Standards-Version: 4.3.0
Homepage: https://github.com/jrprice/Oclgrind
Vcs-Browser: https://salsa.debian.org/opencl-team/oclgrind
Vcs-Git: https://salsa.debian.org/opencl-team/oclgrind.git

Package: liboclgrind-18.3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: core library for Oclgrind
 Oclgrind is an extensible OpenCL device simulator that provides a
 plugin interface to facilitate the creation of tools to aid analysis
 and development of OpenCL programs. Among the tools that Oclgrind
 provides are various debugging aids, such as out-of-bounds memory
 access checking, data-race detection, and an interactive debugger.
 .
 This package provides the core library for Oclgrind, implementing the
 simulator, plugin interface, and providing several built-in plugins.

Package: liboclgrind-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, liboclgrind-18.3 (= ${binary:Version})
Description: development files for Oclgrind
 Oclgrind is an extensible OpenCL device simulator that provides a
 plugin interface to facilitate the creation of tools to aid analysis
 and development of OpenCL programs. Among the tools that Oclgrind
 provides are various debugging aids, such as out-of-bounds memory
 access checking, data-race detection, and an interactive debugger.
 .
 This package provides the development headers and libraries used for
 creating new Oclgrind plugins.

Package: oclgrind
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-18.3
Description: OpenCL device simulator
 Oclgrind is an extensible OpenCL device simulator that provides a
 plugin interface to facilitate the creation of tools to aid analysis
 and development of OpenCL programs. Among the tools that Oclgrind
 provides are various debugging aids, such as out-of-bounds memory
 access checking, data-race detection, and an interactive debugger.
 .
 Oclgrind implements the OpenCL 1.2 runtime API, which makes
 simulating an existing OpenCL program very straightforward - simply
 prefix your usual application command-line with 'oclgrind'. There is
 also a simple interface for simulating individual kernels in
 isolation via the 'oclgrind-kernel' command.
