=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	if [ -d src/CL ]; then mv src/CL src/CL-Do-Not-Use ; fi
	dh_auto_configure -- -DLLVM_DIR=/usr/lib/llvm-7/lib/cmake/llvm

override_dh_auto_clean:
	dh_auto_clean
	find tests/ -name "*.out" -delete
	if [ -d src/CL-Do-Not-Use ]; then mv src/CL-Do-Not-Use src/CL ; fi

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_makeshlibs:
	dh_makeshlibs -Xliboclgrind-rt
