=== debian/watch ===
version=3

https://github.com/jrprice/Oclgrind/releases /jrprice/Oclgrind/archive/v(.*)\.tar\.gz
