## oclgrind 19.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # CMakeLists.txt (Oclgrind)
-# Copyright (c) 2013-2016, James Price and Simon McIntosh-Smith,
+# Copyright (c) 2013-2019, James Price and Simon McIntosh-Smith,
 # University of Bristol. All rights reserved.
 #
 # This program is provided under a three-clause BSD license. For full
@@ -8,8 +8,8 @@
 
 cmake_minimum_required(VERSION 2.8.12)
 project(Oclgrind)
-set(Oclgrind_VERSION_MAJOR 18)
-set(Oclgrind_VERSION_MINOR 3)
+set(Oclgrind_VERSION_MAJOR 19)
+set(Oclgrind_VERSION_MINOR 10)
 
 include(CheckIncludeFiles)
 include(CheckIncludeFileCXX)
@@ -53,17 +53,8 @@
 message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")
 
 # Check LLVM version
-if (${LLVM_PACKAGE_VERSION} VERSION_LESS "3.9")
-  message(FATAL_ERROR "LLVM version must be >= 3.9")
-endif()
-
-# Warn about LLVM 4.0 InstCombine/addrspacecast bug
-if ("${LLVM_VERSION_MAJOR}" STREQUAL "4" AND
-    "${LLVM_VERSION_PATCH}" STREQUAL "0")
-   message(WARNING
-   "There is a known bug with LLVM 4.0.0 that will cause "
-   "Oclgrind to fail on some kernels with a message about "
-   "`addrspacecast`. Use LLVM 3.9 or 4.0.1+ if possible.")
+if (${LLVM_PACKAGE_VERSION} VERSION_LESS "5.0")
+  message(FATAL_ERROR "LLVM version must be >= 5.0")
 endif()
 
 # Add flags for LLVM
@@ -73,14 +64,8 @@
 
 # Get LLVM libraries for linking
 llvm_map_components_to_libnames(LLVM_LIBS
-  bitreader bitwriter core coverage instrumentation ipo irreader
+  bitreader bitwriter core coroutines coverage instrumentation ipo irreader
   linker lto mcparser objcarcopts option target)
-
-if (NOT (${LLVM_PACKAGE_VERSION} VERSION_LESS "4.0"))
-  llvm_map_components_to_libnames(LLVM_COROUTINES coroutines)
-  list(APPEND LLVM_LIBS ${LLVM_COROUTINES})
-endif()
-
 
 # Allow user to set path to Clang installation via CLANG_ROOT
 set (CLANG_ROOT " " CACHE PATH "Root of Clang installation")
@@ -229,8 +214,9 @@
   src/plugins/Uninitialized.h
   src/plugins/Uninitialized.cpp)
 target_link_libraries(oclgrind PRIVATE ${CORE_EXTRA_LIBS}
-  clangFrontend clangSerialization clangDriver clangCodeGen
-  clangParse clangSema clangAnalysis clangEdit clangAST clangLex clangBasic
+  clangCodeGen clangFrontend clangSerialization clangDriver
+  clangParse clangSema clangAnalysis clangEdit clangAST clangASTMatchers
+  clangLex clangBasic
   ${LLVM_LIBS})
 
 if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
@@ -369,3 +355,28 @@
   oclgrind oclgrind-rt oclgrind-rt-icd
   DESTINATION "lib${LIBDIR_SUFFIX}")
 install(FILES
+  ${CORE_HEADERS} ${OPENCL_C_H}
+  DESTINATION include/oclgrind)
+if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
+  install(FILES
+    src/CL/cl.h
+    src/CL/cl_d3d10.h
+    src/CL/cl_d3d11.h
+    src/CL/cl_dx9_media_sharing.h
+    src/CL/cl_egl.h
+    src/CL/cl_ext.h
+    src/CL/cl_gl.h
+    src/CL/cl_gl_ext.h
+    src/CL/cl_platform.h
+    src/CL/opencl.h
+    DESTINATION include/CL)
+endif()
+
+
+# Tests
+enable_testing()
+
+# Check for Python
+find_package(PythonInterp)
+if (PYTHONINTERP_FOUND)
+
