=== debian/changelog ===
oclgrind (19.10-4) unstable; urgency=medium

  * Add dependency on libclang-common-9-dev.  (Closes: #971572)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 16 Jun 2021 16:20:02 +0200

oclgrind (19.10-3) unstable; urgency=medium

  * Fix liboclgrind.so symlink.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 19 Mar 2021 12:16:58 +0100

oclgrind (19.10-2) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Build with llvm-9 (Closes: #968496)

  [ Andreas Beckmann ]
  * Switch to debhelper-compat (= 13).
  * Bump Standards-Version to 4.5.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 16 Aug 2020 15:29:42 +0200

oclgrind (19.10-1) unstable; urgency=medium

  [ James Price ]
  * New upstream release
  * Refresh patches, drop those applied upstream
  * Bump Standards-Version to 4.4.1. No changes needed.
  * Switch to LLVM/Clang 8
  * Use Python 3 (Closes: #943197)

  [ Andreas Beckmann ]
  * Set Rules-Requires-Root: no.

 -- James Price <jamesprice.dev@gmail.com>  Mon, 25 Nov 2019 01:04:06 +0000

oclgrind (18.3-3) unstable; urgency=medium

  * Link against libatomic if needed.
  * Ship liboclgrind-rt-icd.so.
  * Bump Standards-Version to 4.4.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 31 Jul 2019 19:42:30 +0200
