=== debian/control ===
--- 
+++ 
@@ -3,30 +3,31 @@
 Priority: optional
 Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
 Uploaders:
- James Price <j.price@bristol.ac.uk>,
+ James Price <jamesprice.dev@gmail.com>,
  Andreas Beckmann <anbe@debian.org>,
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-exec,
  cmake,
- llvm-7-dev,
- libclang-7-dev,
- clang-7,
+ llvm-9-dev,
+ libclang-9-dev,
+ clang-9,
  libedit-dev,
  zlib1g-dev,
  libreadline-dev,
  opencl-c-headers,
- python,
-Standards-Version: 4.3.0
+ python3,
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Homepage: https://github.com/jrprice/Oclgrind
 Vcs-Browser: https://salsa.debian.org/opencl-team/oclgrind
 Vcs-Git: https://salsa.debian.org/opencl-team/oclgrind.git
 
-Package: liboclgrind-18.3
+Package: liboclgrind-19.10
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, libclang-common-${llvm:Version}-dev, ${misc:Depends}
 Description: core library for Oclgrind
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis
@@ -41,7 +42,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, liboclgrind-18.3 (= ${binary:Version})
+Depends: ${misc:Depends}, liboclgrind-19.10 (= ${binary:Version})
 Description: development files for Oclgrind
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis
@@ -55,7 +56,7 @@
 Package: oclgrind
 Architecture: any
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-18.3
+Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-19.10
 Description: OpenCL device simulator
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis
