=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS  = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

LLVM_VERSION	 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	if [ -d src/CL ]; then mv src/CL src/CL-Do-Not-Use ; fi
	dh_auto_configure -- -DLLVM_DIR=/usr/lib/llvm-$(LLVM_VERSION)/lib/cmake/llvm

execute_after_dh_auto_clean:
	find tests/ -name "*.out" -delete
	if [ -d src/CL-Do-Not-Use ]; then mv src/CL-Do-Not-Use src/CL ; fi

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_makeshlibs:
	dh_makeshlibs -Xliboclgrind-rt

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'llvm:Version=$(LLVM_VERSION)'
