## oclgrind 21.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,9 @@
 # license terms please see the LICENSE file distributed with this
 # source code.
 
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.1)
 project(Oclgrind)
-set(Oclgrind_VERSION_MAJOR 19)
+set(Oclgrind_VERSION_MAJOR 21)
 set(Oclgrind_VERSION_MINOR 10)
 
 include(CheckIncludeFiles)
@@ -21,11 +21,20 @@
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
 endif()
 
+# Require C++14 (hard requirement for LLVM >10)
+set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+
 # Enable rpath on OS X
 set(CMAKE_MACOSX_RPATH 1)
 
+# Enable WIP 3.0 support.
+option(ENABLE_EXPERIMENTAL_OPENCL_3, "Enable experimental OpenCL 3.0 support.")
+if (${ENABLE_EXPERIMENTAL_OPENCL_3})
+  add_definitions(-DENABLE_OPENCL_3)
+endif()
+
 if (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-strict-aliasing")
@@ -53,8 +62,8 @@
 message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")
 
 # Check LLVM version
-if (${LLVM_PACKAGE_VERSION} VERSION_LESS "5.0")
-  message(FATAL_ERROR "LLVM version must be >= 5.0")
+if (${LLVM_PACKAGE_VERSION} VERSION_LESS "11.0")
+  message(FATAL_ERROR "LLVM version must be >= 11.0")
 endif()
 
 # Add flags for LLVM
@@ -63,9 +72,20 @@
 link_directories(${LLVM_LIBRARY_DIRS})
 
 # Get LLVM libraries for linking
-llvm_map_components_to_libnames(LLVM_LIBS
-  bitreader bitwriter core coroutines coverage instrumentation ipo irreader
-  linker lto mcparser objcarcopts option target)
+list(FIND LLVM_AVAILABLE_LIBS LLVM _LLVM_SHARED_INDEX)
+if (${_LLVM_SHARED_INDEX} GREATER -1)
+  set(LLVM_LIBS LLVM)
+else()
+  llvm_map_components_to_libnames(LLVM_LIBS
+    bitreader bitwriter core coroutines coverage frontendopenmp instrumentation
+    ipo irreader linker lto mcparser objcarcopts option target)
+endif()
+
+# https://bugs.llvm.org/show_bug.cgi?id=44870
+list(FIND LLVM_AVAILABLE_LIBS Polly _POLLY_INDEX)
+if (${_POLLY_INDEX} GREATER -1)
+  list(APPEND LLVM_LIBS Polly)
+endif()
 
 # Allow user to set path to Clang installation via CLANG_ROOT
 set (CLANG_ROOT " " CACHE PATH "Root of Clang installation")
@@ -97,8 +117,22 @@
              PATHS "${CLANG_ROOT}/lib" "${LLVM_LIBRARY_DIRS}"
              NO_DEFAULT_PATH)
 find_library(CLANG_LIB "clangFrontend")
+set(CLANG_LIBS
+  clangCodeGen clangFrontend clangSerialization clangDriver
+  clangParse clangSema clangAnalysis clangEdit clangAST clangASTMatchers
+  clangLex clangBasic)
+
 if ("${CLANG_LIB}" STREQUAL "CLANG_LIB-NOTFOUND")
-  message(FATAL_ERROR "Clang libraries not found (set CLANG_ROOT)")
+  # https://releases.llvm.org/10.0.0/tools/clang/docs/ReleaseNotes.html#build-system-changes
+  find_library(CLANG_LIB "clang-cpp"
+               PATHS "${CLANG_ROOT}/lib" "${LLVM_LIBRARY_DIRS}"
+               NO_DEFAULT_PATH)
+  find_library(CLANG_LIB "clang-cpp")
+  set(CLANG_LIBS "clang-cpp")
+
+  if ("${CLANG_LIB}" STREQUAL "CLANG_LIB-NOTFOUND")
+    message(FATAL_ERROR "Clang libraries not found (set CLANG_ROOT)")
+  endif()
 endif()
 
 # Get path to Clang's opencl-c.h header
@@ -111,6 +145,10 @@
   message(FATAL_ERROR "\nClang opencl-c.h not found:\n\t${CLANG_OPENCL_C_H}")
 else()
   message(STATUS "Using opencl-c.h: ${CLANG_OPENCL_C_H}")
+endif()
+
+if (EXISTS "${CLANG_LIB_DIR}/clang/${CLANG_FULL_VERSION}/include/opencl-c-base.h")
+  set(CLANG_OPENCL_C_BASE_H "${CLANG_LIB_DIR}/clang/${CLANG_FULL_VERSION}/include/opencl-c-base.h")
 endif()
 
 # Check for clang
@@ -176,7 +214,6 @@
 set(CORE_HEADERS
   src/core/common.h
   src/core/Context.h
-  src/core/half.h
   src/core/Kernel.h
   src/core/KernelInvocation.h
   src/core/Memory.h
@@ -191,7 +228,6 @@
   src/core/opencl-c.h.cpp
   src/core/common.cpp
   src/core/Context.cpp
-  src/core/half.cpp
   src/core/Kernel.cpp
   src/core/KernelInvocation.cpp
   src/core/Memory.cpp
@@ -213,11 +249,9 @@
   src/plugins/RaceDetector.cpp
   src/plugins/Uninitialized.h
   src/plugins/Uninitialized.cpp)
-target_link_libraries(oclgrind PRIVATE ${CORE_EXTRA_LIBS}
-  clangCodeGen clangFrontend clangSerialization clangDriver
-  clangParse clangSema clangAnalysis clangEdit clangAST clangASTMatchers
-  clangLex clangBasic
-  ${LLVM_LIBS})
+target_link_libraries(oclgrind
+  PRIVATE ${CORE_EXTRA_LIBS} ${CLANG_LIBS}
+  PUBLIC ${LLVM_LIBS})
 
 if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
   target_link_libraries(oclgrind PRIVATE Version)
@@ -275,12 +309,23 @@
 
 add_custom_target(OPENCL_C_HEADERS ALL DEPENDS ${OPENCL_C_H})
 
+if (CLANG_OPENCL_C_BASE_H)
+  add_custom_command(
+    OUTPUT include/oclgrind/opencl-c-base.h
+    POST_BUILD
+    COMMAND ${CMAKE_COMMAND} -E
+      copy ${CLANG_OPENCL_C_BASE_H} include/oclgrind/opencl-c-base.h
+    DEPENDS ${CLANG_OPENCL_C_BASE_H})
+  set(OPENCL_C_H_DEPENDS include/oclgrind/opencl-c-base.h)
+  set(OPENCL_C_H ${OPENCL_C_H} ${CMAKE_BINARY_DIR}/${OPENCL_C_H_DEPENDS})
+endif()
+
 add_custom_command(
   OUTPUT include/oclgrind/opencl-c.h
   POST_BUILD
   COMMAND ${CMAKE_COMMAND} -E
     copy ${CLANG_OPENCL_C_H} include/oclgrind/opencl-c.h
-  DEPENDS ${CLANG_OPENCL_C_H})
+  DEPENDS ${CLANG_OPENCL_C_H} ${OPENCL_C_H_DEPENDS})
 
 # Generate precompiled headers for opencl-c.h
 set(OPENCL_C_H_SYSROOT "${CMAKE_BINARY_DIR}/include/oclgrind/")
@@ -319,64 +364,3 @@
     -cc1 -x cl -cl-std=CL2.0 -O0 -fno-builtin -fgnu89-inline
     -emit-pch -triple spir-unknown-unknown
     -relocatable-pch -isysroot "${OPENCL_C_H_SYSROOT}"
-    include/oclgrind/opencl-c.h
-    -o include/oclgrind/opencl-c-2.0-32.pch
-  DEPENDS include/oclgrind/opencl-c.h
-)
-add_custom_command(
-  OUTPUT include/oclgrind/opencl-c-2.0-64.pch
-  POST_BUILD
-  COMMAND
-    ${CLANG}
-    -cc1 -x cl -cl-std=CL2.0 -O0 -fno-builtin -fgnu89-inline
-    -emit-pch -triple spir64-unknown-unknown
-    -relocatable-pch -isysroot "${OPENCL_C_H_SYSROOT}"
-    include/oclgrind/opencl-c.h
-    -o include/oclgrind/opencl-c-2.0-64.pch
-  DEPENDS include/oclgrind/opencl-c.h
-)
-
-
-# Generate config.h
-set(LLVM_VERSION ${LLVM_VERSION_MAJOR}${LLVM_VERSION_MINOR})
-configure_file("config.h.in" "config.h")
-
-
-# Generate ICD loader if not on Windows
-if (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
-  file(GENERATE OUTPUT ${CMAKE_BINARY_DIR}/oclgrind.icd
-       CONTENT "${CMAKE_INSTALL_PREFIX}/lib${LIBDIR_SUFFIX}/$<TARGET_FILE_NAME:oclgrind-rt-icd>\n")
-endif()
-
-install(TARGETS
-  oclgrind-exe oclgrind-kernel
-  DESTINATION bin)
-install(TARGETS
-  oclgrind oclgrind-rt oclgrind-rt-icd
-  DESTINATION "lib${LIBDIR_SUFFIX}")
-install(FILES
-  ${CORE_HEADERS} ${OPENCL_C_H}
-  DESTINATION include/oclgrind)
-if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
-  install(FILES
-    src/CL/cl.h
-    src/CL/cl_d3d10.h
-    src/CL/cl_d3d11.h
-    src/CL/cl_dx9_media_sharing.h
-    src/CL/cl_egl.h
-    src/CL/cl_ext.h
-    src/CL/cl_gl.h
-    src/CL/cl_gl_ext.h
-    src/CL/cl_platform.h
-    src/CL/opencl.h
-    DESTINATION include/CL)
-endif()
-
-
-# Tests
-enable_testing()
-
-# Check for Python
-find_package(PythonInterp)
-if (PYTHONINTERP_FOUND)
-
