=== debian/changelog ===
oclgrind (21.10-4) unstable; urgency=medium

  * Fix building with -Werror=implicit-function-declaration.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 22 Mar 2024 16:26:14 +0100

oclgrind (21.10-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063225

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 01:42:15 +0000

oclgrind (21.10-3) unstable; urgency=medium

  * Switch to LLVM/Clang 14.  (Closes: #1017654)
  * Bump Standards-Version to 4.6.2. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 04 Jan 2023 14:16:19 +0100

oclgrind (21.10-2) unstable; urgency=medium

  * Add salsa-ci.yml.
  * Switch from obsolete CL_EXT_* to CL_API_* macros.  (Closes: #1022306)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 23 Oct 2022 23:18:45 +0200

oclgrind (21.10-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * Switch to LLVM/Clang 13 (Closes: #974793)
  * Bump Standards-Version to 4.6.0. No changes needed.

 -- James Price <jamesprice.dev@gmail.com>  Sat, 23 Oct 2021 13:08:28 +0000
