=== debian/control ===
--- 
+++ 
@@ -9,21 +9,27 @@
  debhelper-compat (= 13),
  dh-exec,
  cmake,
- llvm-9-dev,
- libclang-9-dev,
- clang-9,
+ llvm-14-dev,
+ libclang-14-dev,
+ libpolly-14-dev,
+ clang-14,
  libedit-dev,
  zlib1g-dev,
  libreadline-dev,
  opencl-c-headers,
  python3,
+# prevent accidental backports after the 64-bit time_t transition
+ dpkg-dev (>= 1.22.5),
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/jrprice/Oclgrind
 Vcs-Browser: https://salsa.debian.org/opencl-team/oclgrind
 Vcs-Git: https://salsa.debian.org/opencl-team/oclgrind.git
 
-Package: liboclgrind-19.10
+Package: liboclgrind-21.10t64
+Provides: ${t64:Provides}
+Replaces: liboclgrind-21.10
+Breaks: liboclgrind-21.10 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -42,7 +48,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, liboclgrind-19.10 (= ${binary:Version})
+Depends: ${misc:Depends}, liboclgrind-21.10t64 (= ${binary:Version})
 Description: development files for Oclgrind
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis
@@ -56,7 +62,7 @@
 Package: oclgrind
 Architecture: any
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-19.10
+Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-21.10t64
 Description: OpenCL device simulator
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis
