=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%oclgrind-$1.tar.gz%" \
  https://github.com/jrprice/Oclgrind/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
